' ------------------------------------------------------
'      IBM RATIONAL PROGRAMMING PATTERNS (RPP)
'
' ------------------------------------------------------
Set WshShell = Wscript.CreateObject("Wscript.Shell")
Set Args = Wscript.Arguments
Set WshEnv = WshShell.Environment("PROCESS")
Set WshVolEnv = WshShell.Environment("VOLATILE")
Dim FSO
Set  FSO = CreateObject("Scripting.FileSystemObject")
Dim ObjProcess
Set  ObjProcess = CreateObject("BvpWsh2.Process")
Const ForReading = 1, ForWriting = 2, ForAppending = 8
BVP_Title = "Migration RPP"
Dim LogMsg
Dim Fldr , Flds
Dim RetB
Dim FilAss
Dim Val
Dim StepPgm
Dim  Nls_Lib
Public Return
Public RetGp
Public Fic_Input
Public Fic_Input2
Public Base
'Default values
Dim MsgTyp
MsgTyp = 2
Dim c_error
c_error = 0
Dim TypInput
TypInput = 9
M_pattern = "^ *" & vbcrlf
Dim DelDo
DelDo = WshEnv("DelDo")
If DelDo = "" Then
   DelDo = "YES"
End If
'DelDo = "NO"
Dim BVPTrace
BVPTrace = WshEnv("BVPTrace")
'BVPTrace = "YES"
If BVPTrace = "" Then
   BVPTrace = "NO"
End If
Dim Cobol
Cobol = "Microfocus"
Dim CTF
CTF = WshEnv("CTF")
If CTF = "" Then
   CTF = "NO"
End If
 RepWnt =    WshEnv("TMP")
  If RepWnt = "" Then
     RepWnt =    WshEnv("TEMP")
  End If
  If RepWnt = "" Then
     RepWnt = "c:"
  End If
Dim NumP
NumP = 0
Dim NuJob
NuJob = 0
Dim U_cod
U_cod = ""
Dim P_cod
P_cod = ""
Dim BVP_User
BVP_User = ""
err.number = 0
WshVolEnv("RC") = 0
Msg = "Abnormal End of Job."
Dim oService
Dim bRep
Dim ArrayProc, TProc
ArrayProc = array ( "UTCA", _
                    "UTCG", _
                    "UTSE", _
                    "UTMA", _
                    "UTCR", _
                    "UTFL", _
                    "UTOV" )
Dim PBelong
PBelong = "   "
Dim ArraySpgm, TProcStep
ArraySpgm = array ( "BVPACA10", _
                    "BVPACA20", _
                    "BVPACA30" )
Dim BVPSpgm
BVPSpgm = "   "

'==========================================================
'FUNCTION and SUB
'==========================================================

'                       Set COBOL environment :
 Function Cob_Env ()
'=========================================================
Rep_PRD = "HKLM\SOFTWARE\IBM\BVP VisualAge Pacbase 3.5\"
On Error Resume Next
Cobol = WshShell.RegRead (Rep_PRD & "Server\Cobol")
Dim pos
pos = InStr(Cobol,"MicroFocus")
If pos <> 0 Then
   Cobol = "Microfocus"
End If
If Ret <> "" Then
   Cobol = Ret
End If

Cob_Env = 0
If Cobol <> "Microfocus" Then
    Cob_Env = 1
    Exit Function
End If

' MICROFOCUS :
' ------------
If Cobol = "Microfocus" Then
 Var = "HKLM\SOFTWARE\Micro Focus\NetExpress\"
 NetExpress = 0
 ApplicationServer = 0

 On Error Resume Next
 NetExpress_Version = WshShell.RegRead (Var & _
        "DefaultVersion")
 If Err.Number = 0 Then
    NetExpress = 1
 End If

 On Error Resume Next
 If NetExpress_Version < "5.0" Then
  NetExpress_Version = WshShell.RegRead (Var & _
                          "Version")
  If Err.Number = 0 Then
     ApplicationServer = 1
 End If
 Else
    ApplicationServer = 1
 End If

 If NetExpress = 1 or ApplicationServer = 1 Then
    Var = Var & NetExpress_Version & "\COBOL\"
    COBOL_Version = WshShell.RegRead (Var & "Version")
    Var = Var & COBOL_Version & "\Environment\"
    COBPATH =  WshShell.RegRead (Var & "PATH")
    WshEnv("COBDIR") = WshShell.RegRead (Var & "COBDIR")
    WshEnv("COBHNF") = WshShell.RegRead (Var & "COBHNF")
    WshEnv("PATH") = COBPATH & ";" & WshEnv("PATH")
    WshEnv("LOCK_MODE") = "0"
    MFPgms = WshShell.RegRead (Rep_PRD & "Server\Cobol")

    If MFPgms = "MicroFocus V5.1" Then
    WshEnv("FS_LOCAL") = "ON"
    End If
    FSLOCAL = WshEnv("FS_LOCAL")
   'WshEnv("BVPRB") = "N"
    BVPRB = WshEnv("BVPRB")

    If BVPRB = "" Then
     If FSLOCAL= "" Then
        BVPRB = "N"
        Else
        Select Case Myproc
         Case "UPDT"
          BVPRB = "Y"
         Case "UPDP"
          BVPRB = "Y"
         Case "UPGP"
            BVPRB = "Y"
         Case "UTM2"
            BVPRB = "Y"
         Case "HIPM"
            BVPRB = "Y"
         Case Else
            BVPRB = "N"
         End Select
     End If
    End If

    If NetExpress_Version > "4.0" and BVPTrace="YES" Then
      'Consolidated Trace Facility
      CTF = "YES"
    End If
 Else
    Cob_Env = 1
    Exit Function
 End If
End If
End Function

'                       Find of Job Number :
 Function Num_Job (Fil1)
'==========================================================
'Search for JB card
  NuJob = 0
  Set NJfil = FSO.GetFile(Fil1)
  Set R_NJfil = NJfil.OpenAsTextStream(ForReading)
  Do While R_NJfil.AtEndOfStream <> TRUE _
               and R_NJfil.line < 4
    Line = R_NJfil.ReadLine
    If Mid(Line, 2, 2) = "JB" Then
      NuJob = Replace (Mid(Line, 12, 4) , " " , 0 )
    End If
  Loop
  R_NJfil.Close
End Function


'                       Find or Type User/PassWord :
Function Usr_Pw (Fil3)
'==========================================================
Usr_Pw = 0
Option_Proc = "XXXX"

'Search for * card
j = 0
ExistCard = False
Titre_Login = BVP_Title & " . " & MyProc
User_Label = "User Name"
Password_Label = "Password"
'With NLS : read file for the label names

Set UPfil = FSO.GetFile(Fil3)
Set R_UPfil = UPfil.OpenAsTextStream(ForReading)
Do While R_UPfil.AtEndOfStream <> TRUE
  j = j + 1
  Line = R_UPfil.ReadLine
  If Mid(Line, 2, 1) = "*" Then
    ExistCard = True
    U_cod = Mid(Line, 3, 8)
    P_cod = Mid(Line, 11, 8)
    Option_Proc = Mid(Line, 29, 4)
    LineStar = Line
  End If
  If ExistCard = True Then Exit Do End If
Loop
R_UPfil.Close

If U_cod = "" or U_cod = "        " _
or IsNull(U_cod) = True or ExistCard = False   Then
   LRep = FALSE
Else
   Exit Function
End If

Do While LRep = FALSE
  Set ObjLogin = CreateObject ("BvpWsh2.Login")
  LRep = ObjLogin.TxtInput(Titre_Login, User_Label, _
        Password_Label)

  If LRep = TRUE Then
     U_cod = ObjLogin.GetVal(1)
     P_cod = ObjLogin.GetVal(2)
     If U_cod = "" or U_cod = "        " _
        or IsNull(U_cod) = True  Then
        LRep = FALSE
     End If
 Else
  Usr_Pw = 9
  WshVolEnv("RC") = 1
  Exit Function
 End If

Loop

' write * card
Dim U_cod8
U_cod8 = Mid(U_cod & space(8), 1, 8)
Dim P_cod8
P_cod8 = Mid(P_cod & space(8), 1, 8)

     TabPath = Split(Fil3, "\", -1, 1)
     IxFile = UBound ( TabPath )
     FileI = TabPath (IxFile)
     FileL = FileI & ".LOG"
     FileLog = Replace ( Fil3 , FileI , FileL )

     Set F2Input = FSO.CreateTextFile(FileLog, TRUE)
     F2Input.Close

If ExistCard = True Then
  L_star = Mid(LineStar, 19, 62)
  L_star = Replace (L_star , chr(13) , " ")
  L_star = Replace (L_star , chr(10) , " ")
  L_star = Replace (L_star , "" , " ")
End If

Set UPfil = FSO.GetFile(Fil3)

If ExistCard = False Then
'Create first line

   LineStar = " *" & U_cod & Space(n) & P_cod & Space(p)
   Option_Proc = "    "

   Set W_F2Input = FSO.OpenTextFile( FileLog , ForWriting)
   W_F2Input.WriteLine (LineStar)
   Set R_UPfil = UPfil.OpenAsTextStream(ForReading)
   Do While R_UPfil.AtEndOfStream <> TRUE
     LineR = R_UPfil.ReadLine
     W_F2Input.WriteLine (LineR)
   Loop
   R_UPfil.Close
   W_F2Input.Close
Else
'Rewrite star card

  j = 0

  Set W_F2Input = FSO.OpenTextFile( FileLog , ForWriting)
  Set R_UPfil = UPfil.OpenAsTextStream(ForReading)
  Do While R_UPfil.AtEndOfStream <> TRUE
     LineR = R_UPfil.ReadLine
     If Mid(LineR , 2, 1) = "*" and j = 0 Then
      LineR = " *" & U_cod & Space(n) & P_cod  _
       & Space(p) & L_star
      j = 1
     End If
     W_F2Input.WriteLine (LineR)
   Loop
   R_UPfil.Close
   W_F2Input.Close
End If

If fso.FileExists (Fil3) Then
 DelFile (Fil3)
End If
        Fic_Input = FileLog

End Function


'                       Create a new folder :
Function CreateFldr(RepFld)
'==========================================================
 If  FSO.FileExists(RepFld) Then
   Set Fldr = FSO.GetFolder (RepFld)
 Else
   Set Fldr = FSO.CreateFolder (RepFld)
 End If
   CreateFldr = Fldr.Path
End Function

'                       Delete a new folder :
Function DeleteFldr (RepFld)
'==========================================================
   On error resume next
   Set FldS = FSO.GetFolder (RepFld)
   If err.number <> 0 Then Exit Function End If
   If DelDo = "YES" Then
      FldS.Delete
   End If
End Function

'                       Delete file :
Sub DelFile (FicD)
'==========================================================

Dim FileD
If  FSO.FileExists(FicD) Then
Set FileD = FSO.GetFile(FicD)
FileD.Delete
End If
End Sub

'                       Create a NULL File :
Function CreateNULF(NF)
'==========================================================
  If Not FSO.FileExists(NF) Then
              Set NFile = FSO.CreateTextFile(NF, TRUE)
              NFile.Close
  End If
End Function

'                       Error Messages :
Sub Msg_Log (Nls_Args)
'==========================================================

Dim Nls_File, Nls_Num
Nls_Num = Nls_Args(0)
Nls_Lib = ""
'Search for Nls_Num in error file
Nls_File = Rep_NLS & "\BvpMsg_E.txt"
If Not FSO.FileExists(Nls_File) Then
  Nls_Lib = "Error File not found: " & Nls_File
Else
  Set Nls1 = FSO.GetFile(Nls_File)
  Set R_Nls = Nls1.OpenAsTextStream()
  Do While R_Nls.AtEndOfStream <> TRUE
    Line = R_Nls.ReadLine
    If Mid(Line, 4, 4) = Nls_Num Then
      Nls_Lib = Nls_Lib & Mid(Line, 10, 70)
    End If
  Loop
  If Nls_Lib = "" Then
    Nls_Lib = "Message " _
    & Nls_Num & " not found in the Error File."
  End If
  R_Nls.Close
End If

' Parameter replacement
ParmNum = 1
Do While Parmnum <= Ubound(Nls_Args)
  Nls_Lib = Replace(Nls_Lib, "$" & ParmNum, _
                        Nls_Args(ParmNum))
  ParmNum = ParmNum + 1
Loop

'Display or Write in log file
Select Case MsgTyp
  Case 1
    MyBox = MsgBox(MyProc & ": " & Nls_Lib, 0 , BVP_Title)
  Case 2
   If FSO.FolderExists(Rep_USR) Then
      If Not FSO.FileExists(Rep_USR & "\" & MyProc _
                              & "MSG.LOG") Then
               Set LogF = FSO.CreateTextFile(Rep_USR & "\" _
                & MyProc & "MSG.LOG", TRUE)
               LogF.Close
  Set LogF= FSO.GetFile(Rep_USR & "\" & MyProc _
                              & "MSG.LOG")
                Set I_Log = LogF.OpenAsTextStream(ForAppending)

  I_Log.WriteLine ( Date() & " " & Time ())

  If BVPTrace = "YES" Then
     I_Log.WriteLine ("Admin database directory : " & Rep_ABASE)
     I_Log.WriteLine ("Admin backup directory : " & Rep_ASAVE)
     I_Log.WriteLine ("Admin database journal directory: " & _
                      Rep_AJOURNAL)
     I_Log.WriteLine ("Development database directory : " & _
                      Rep_BASE)
     I_Log.WriteLine ("Development backup directory : " & _
                      Rep_SAVE)
     I_Log.WriteLine ("Development database journal" & _
                      " directory : " & Rep_JOURNAL)
     End If

     I_Log.Close
    Else
    Set LogF = FSO.GetFile(Rep_USR & "\" & MyProc & "MSG.LOG")
    End If
   Else
    If FSO.FolderExists(Rep1_USR) Then
       If Not FSO.FileExists(Rep1_USR & "\" & MyProc _
                              & "MSG.LOG") Then
                Set LogF = FSO.CreateTextFile(Rep1_USR & "\" _
                & MyProc & "MSG.LOG", TRUE)
                LogF.Close
         Set LogF= FSO.GetFile(Rep1_USR & "\" & MyProc _
                              & "MSG.LOG")
                Set I_Log = LogF.OpenAsTextStream(ForAppending)

  I_Log.WriteLine ( Date() & " " & Time ())

  If BVPTrace = "YES" Then
     I_Log.WriteLine ("Admin database directory : " & Rep_ABASE)
     I_Log.WriteLine ("Admin backup directory : " & Rep_ASAVE)
     I_Log.WriteLine ("Admin database journal directory: " & _
                       Rep_AJOURNAL)
     I_Log.WriteLine ("Development database directory : " & _
                       Rep_BASE)
     I_Log.WriteLine ("Development backup directory : " & _
                       Rep_SAVE)
     I_Log.WriteLine ("Development database journal " & _
                       " directory : " & Rep_JOURNAL)
     End If

  I_Log.Close
      Else
      Set LogF = FSO.GetFile(Rep1_USR & "\" & MyProc _
                              & "MSG.LOG")
      End If
   End If
  End If

   If Not FSO.FolderExists(Rep_USR) and _
      Not FSO.FolderExists(Rep1_USR) Then
       Msg = "User's directory doesn't exist." & _
                       "(missing argument)"
       DisplayInfo (Msg)
       Exit Sub
   End If

    Set W_Log = LogF.OpenAsTextStream(ForAppending)
    W_Log.WriteLine (Nls_Lib)
    W_Log.Close
    If Nls_Num = "1023"  Then
        DisplayInfo ("End of Job.")
    End If

  Case 3
    'Message inhibited ... but label is found
End Select

End Sub

'                       Error processing :
Sub Err_Cod (Ret , Val, StepPgm)
'==========================================================

If Ret > Val and Ret <> 0  Then
'For the GPRT : Ret < ou = 10 it is ok
WshVolEnv("RC") = Ret
If Ret = 99 Then
Call Msg_Log (Array("9999", StepPgm, Ret))
Else
Call Msg_Log (Array("1025", StepPgm, Ret))
End If
Call DeleteFldr (Rep_TMP)
If MsgTyp = "2" Then
DisplayInfo (Msg)
End If
Wscript.Quit (Ret)
End If

End Sub


Sub CopFil (F1 , F2)
'==========================================================

  Set MyEntry = FSO.GetFile(F1)
      Set R_MyEntry = MyEntry.OpenAsTextStream()
      Set MyOutput = FSO.GetFile(F2)
      Set W_MyOutput = MyOutput.OpenAsTextStream(ForAppending)

      Do While R_MyEntry.AtEndOfStream <> TRUE
      Line = R_MyEntry.ReadLine
      W_MyOutput.WriteLine (Line)
      Loop

      W_MyOutput.Close
      R_MyEntry.Close

End Sub

'                       Execution cmd  :
Function RunCmdLog (NamPgm)
'==========================================================
Call TabProc ( ArraySpgm, NamPgm , BVPSpgm )
If Cobol = "Microfocus" Then
   RLog = chr(34) & Rep_USR & "\DISP" _
          & MyProc & ".log" & chr(34)
   RCmd = "cmd.exe /c "
   If BVPTrace = "YES" Then
    If CTF = "YES" Then
      Rep_INST =  WshShell.RegRead _
      ("HKLM\SOFTWARE\IBM\BVP VisualAge Pacbase 3.5\")
      F1 = Rep_INST & "Server\Config\Ctf\mftrace.cfg"
      F2 = Rep_INST & "Server\Config\Ctf\mftrace.txt"
      Set MyEntry = FSO.GetFile(F1)
      Set R_MyEntry = MyEntry.OpenAsTextStream()
      If not fso.FileExists(F2) Then
         Set MyOutput = FSO.CreateTextFile(F2,true)
      End If
      Set MyOutput = FSO.GetFile(F2)
      Set W_MyOutput = MyOutput.OpenAsTextStream(ForWriting)

      Do While R_MyEntry.AtEndOfStream <> TRUE
       Line = R_MyEntry.ReadLine
       If Mid(Line, 1, 34) = _
       "mftrace.emitter.textfile#location=" Then
         Line="mftrace.emitter.textfile#location=" & Rep_USR
       End If
       W_MyOutput.WriteLine (Line)
      Loop

      W_MyOutput.Close
      R_MyEntry.Close
      Ret = FSO.CopyFile(F2 , F1)
      MyOutput.Delete
      WshEnv("MFTRACE_CONFIG") = F1
    End If

      RCmdLog = " 1>> " & RLog & " 2>&1"
      If BVPSpgm = "NO" Then
         Return = WshShell.run(Rcmd & NamPgm & ".exe -s "  _
               & RCmdLog , 1 , TRUE)
   Else
         Return = WshShell.run(Rcmd & "BVPACALL.exe " & _
               NamPgm & " -s" & RCmdLog , 1 , TRUE)
      End If
   Else
      RCmdLog = " 1>> " & RLog
      If BVPSpgm = "NO" Then
      Return = WshShell.Run(RCmd & NamPgm & ".exe -s "  _
               & RCmdLog , 2 , TRUE)
      Else
         Return = WshShell.run(Rcmd & "BVPACALL.exe " & _
               NamPgm & " -s" & RCmdLog , 2 , TRUE)
      End If
   End If
End If

End Function

'                       End of job
Function EndJob  (ValEnd)
'==========================================================
       WshVolEnv("RC") = ValEnd
       c_error =  ValEnd
       If c_error <> 0 Then
          DisplayInfo (Msg)
          c_error = 1
       End If

End Function

'                       Environment Assignment :
Function BvpEnv(step,var,valinit)
'==========================================================

  valstep=WshEnv(step & "_" & var)
  valproc=WshEnv(MyProc & "_" & var)
  If valstep = "" Then
     If valproc = "" Then
        WshEnv(var) = valinit
     Else
        WshEnv(var) = valproc
     End If
  Else
     WshEnv(var) = valstep
  End If

End Function

'                       Function Resource line :
Function Epur (patrn, strng)
'==========================================================

  Dim regEx, Match, Matches
  Set regEx = New RegExp
  regEx.Pattern = patrn
  regEx.IgnoreCase = True
  regEx.Global = True
Do
  Set Matches = regEx.Execute(strng) ' Lance la recherche.
  For Each Match in Matches ' Itre la collection Matches.
       strng = mid(strng,len(match.value) + 1)
  Next
loop while matches.count <> 0

End Function

'                       End of  Job DISPLAY :
Sub DisplayInfo(Msg)
'==========================================================

   time_out = 2
   button = vbInformation
   WshShell.Popup Msg, time_out, MyProc , button
End Sub


'                  If procedure belong to list or not :
Function TabProc (Tableau , Prm1 , Result)
'==========================================================
  iMax = UBound (Tableau)
  iArray = 0
 Do While iArray < iMax + 1
    Result = "NO"
    If Tableau (iArray) = Prm1 Then
       Result = "YES"
       Exit Do
    End If
    iArray = iArray + 1
  Loop
End Function

'==========================================================
'==========================================================
'        CORE
'==========================================================
'==========================================================

' Set VaPac and Migration environment :
' -------------------------------------

Rep_BVP="HKLM\SOFTWARE\IBM\BVP VisualAge Pacbase 3.5\Server\BVP"
Rep_MIG="HKLM\SOFTWARE\IBM\Migration RPP\Server\MIG"

Rep_SYS = Rep_BVP & "_SYS"
Rep_SYSM = Rep_MIG & "_SYS"
Rep_SKEL = WshShell.RegRead (Rep_SYSM & "\SKEL\")
Rep_SKELP = WshShell.RegRead (Rep_SYS & "\SKEL\")
Rep_NLS  = WshShell.RegRead (Rep_SYS & "\NLS\")
Rep_PROC = WshShell.RegRead (Rep_SYSM & "\PROC\")
Rep_PGM  = WshShell.RegRead (Rep_SYSM & "\PGM\")
Rep_PGMP = WshShell.RegRead (Rep_SYS & "\PGM\")
WshEnv("PATH") = Rep_PGMP & ";" & WshEnv("PATH")
WshEnv("PATH") = Rep_PGM & ";" & WshEnv("PATH")

Rep_A = Rep_BVP & "_DATA\ADMIN"
Rep_ABASE    = WshShell.RegRead (Rep_A & "\BASE\")
Rep_ASAVE    = WshShell.RegRead (Rep_A & "\SAVE\")
Rep_AJOURNAL = WshShell.RegRead (Rep_A & "\JOURNAL\")
Rep1_ATMP    = WshShell.RegRead (Rep_A & "\TMP\")
Rep1_AUSR    = WshShell.RegRead (Rep_A & "\USERS\")

' Argument control :
' ----------------
  If Args.Count = 0 Then
      MsgTyp = 3
      Rep1_USR = Rep_BVP & "_DATA\"
      Call Msg_Log (Array("1002"))
      Msg = Nls_Lib
      EndJob (1)
   End If

' Kind of display :
' ----------------
  BVP_Msg = WshEnv("BVP_Msg")
  Select Case BVP_Msg
  Case "1"
      'msg interactive
      MsgTyp = 1
  Case "2"
      'msg in file (default)
      MsgTyp = 2
  Case "3"
      'no msg
      MsgTyp = 3
  End Select

If c_error = 0 Then
   Base   = Args(0)
   'Base checking
   '----------------
   Base = Ucase(Args(0))
    Rep_D = Rep_BVP & "_DATA\" & Base
    On Error Resume Next
    Rep_BASE = WshShell.RegRead (Rep_D & "\BASE\")
    Rep_MD   = WshShell.RegRead (Rep_D & "\")
    If  Err.Number <> 0 Then
      Rep1_USR = Rep_BVP & "_DATA\"
      Call Msg_Log (Array("1051" , Base))
      c_error = 1
    End If
End If

If c_error = 0 Then
   'User checking
   '----------------
   BVP_User = Ucase(Args(1))
   If BVP_User = "" or BVP_User = " " Then
       Call TabProc ( ArrayProc, MyProc , PBelong )
       If PBelong = "YES" Then
        Rep1_USR = Rep_BVP & "_DATA\"
        Call Msg_Log (Array("9966"))
        c_error = 1
       End If
   End If
End If

If c_error = 0 Then

   Rep_D = Rep_BVP & "_DATA\" & Base
   Rep_D2 = Rep_MIG & "_DATA\" & Base
   Rep_BASE    = WshShell.RegRead (Rep_D & "\BASE\")
   Rep_JOURNAL = WshShell.RegRead (Rep_D & "\JOURNAL\")
   Rep_SAVE    = WshShell.RegRead (Rep_D & "\SAVE\")
   Rep1_TMP    = WshShell.RegRead (Rep_D2 & "\TMP\")
   Rep1_USR    = WshShell.RegRead (Rep_D2 & "\USERS\")

   Rep_SCRIPT  = WshShell.RegRead (Rep_D2 & "\SCRIPT\")

   ' Concurrent batch-TP update

   WshEnv("SEMLOCK") = Rep_BASE & "\LO"
   WshEnv("SEMADMIN") = Rep_ABASE & "\LO"

   ' GPRT Serialization

   'WshEnv("BVPSB") = "Y"
   WshEnv("SEMQUEUE") = Rep_BASE & "\SB"
   WshEnv("SEMBIDON") = Rep_BASE & "\XX"

   If Not FSO.FolderExists(Rep1_TMP)or _
   Not FSO.FolderExists(Rep1_USR) Then
      EndJob (1)
   Else
   Set Rep1_TMP = FSO.GetFolder (Rep1_TMP)
   Set Rep1_USR = FSO.GetFolder (Rep1_USR)
   End If

   If Not FSO.FolderExists(Rep1_ATMP) or _
   Not FSO.FolderExists(Rep1_AUSR) Then
      EndJob (1)
   Else
      FSO.GetFolder (Rep1_ATMP)
      FSO.GetFolder (Rep1_AUSR)
   End If
End If

' Set COBOL environment :
' It's mandatory to have TMP directory defined
' --------------------------------------------

CobEnvR = Cob_Env ()
If CobEnvR = 1 Then
     Call Msg_Log (Array("9977"))
     c_error = 1
     EndJob (1)
End If

' Set Migration Procedure environment :
' -------------------------------------
If c_error = 0 Then

   NumP = ObjProcess.GetPID()

   BVP_Input = WshEnv("BVP_Input")
   If (BVP_Input = "") Then
      BVP_Resource = WshEnv("BVP_Resource")
      Call Epur(M_pattern,BVP_Resource)
     If (BVP_Resource <> "") Then

      If Not FSO.FolderExists(Rep1_TMP & "\" & BVP_User) Then
            Rep_TMP = CreateFldr(Rep1_TMP & "\" & BVP_User)
       End If
       Fica = Rep1_TMP & "\" & BVP_User & "\" & MyProc _
                     & "_" & NumP & "a"

       Fic_Input = Fica
       Set o = FSO.OpenTextFile(Fic_Input, 2, True)
       o.Write BVP_Resource
       o.Close

         TypInput = 1 'user input with resource
      Else
         TypInput = 0 'no user input
      End If
   Else
      Fic_Input = WshEnv("BVP_Input")
      TypInput = 2 'user input in file
   End If

   If TypInput <> 0 Then
     ' Search of User Name
     If BVP_User = "" or BVP_User = " " Then
                  U_error = Usr_Pw (Fic_Input)
                 If U_error <> 0 Then
                     Call Msg_Log (Array("9965"))
                     c_error = 1
                  else
                     BVP_User = U_Cod
                  BVP_Opt = Option_Proc
     End If
   End If
End If

If c_error = 0 Then
' Procedure with input
   Call TabProc ( ArrayProc, MyProc , PBelong )
   If PBelong = "NO" Then

   If TypInput = 0 Then
       Call Msg_Log (Array("1003"))
       c_error = 1
   Else
   Call Num_Job (Fic_Input)

   If NuJob <> 0 Then  NumP = NuJob End If

   End If
   End If

End If

If c_error = 0 Then

   Dim E1_Rep
   Dim E2_Rep

   BVP_Tiret = "-"
   On error resume next

   If BVP_User = "" Then
      E1_Rep = "\" & MyProc & BVP_Tiret & NumP
      Rep_TMP = CreateFldr(Rep1_TMP & E1_Rep)
      Rep_USR = CreateFldr(Rep1_USR & E1_Rep)
   Else
      E2_Rep = "\" & BVP_User & "\" & MyProc & BVP_Tiret & NumP
      If Not FSO.FolderExists(Rep1_USR & "\" & BVP_User) Then
         Rep_USR = CreateFldr( Rep1_USR & "\" & BVP_User)
      End If
      If Not FSO.FolderExists(Rep1_TMP & "\" & BVP_User) Then
         Rep_TMP = CreateFldr(Rep1_TMP & "\" & BVP_User)
      End If
      If Not FSO.FolderExists(Rep1_USR & E2_Rep) Then
         Rep_USR = CreateFldr(Rep1_USR & E2_Rep)
         Rep_TMP = CreateFldr(Rep1_TMP & E2_Rep)
      Else
         NumP = NumP & Timer
         E2_Rep = "\" & BVP_User & "\" & MyProc _
                               & BVP_Tiret & NumP
         Rep_USR = CreateFldr( Rep1_USR & E2_Rep)
         Rep_TMP = CreateFldr( Rep1_TMP & E2_Rep)
      End If
   End If

'--------------------------------
' TRUNCATURED TO 80 CH.

   If  FSO.FileExists(Fic_Input) _
     and TypInput = 1 Then
     ' Input with Resource only is temporary
     Ret = fso.MoveFile (Fic_Input , Rep_TMP & "\INFILE")
     Fic_Input = Rep_TMP & "\INFILE"
     Set MyEntry = FSO.GetFile(Fic_Input)

     Fic_Input2 = Rep_TMP & "\INFILE2"
     Set MyOutput = FSO.CreateTextFile(Fic_Input2,true)
     Set MyOutput = FSO.GetFile(Fic_Input2)

     Set R_MyEntry = MyEntry.OpenAsTextStream()
     Set W_MyOutput = MyOutput.OpenAsTextStream(ForAppending)

     Do While R_MyEntry.AtEndOfStream <> TRUE
      Line = R_MyEntry.ReadLine
      W_MyOutput.WriteLine (Left(Line,80))
     Loop
     W_MyOutput.Close
     R_MyEntry.Close

     Ret = FSO.CopyFile(Rep_TMP & "\INFILE2" , Rep_TMP & _
     "\INFILE")

   End If
   ' USERS directory common all procedures :
   If BVP_User = "" Then
      If Not FSO.FolderExists(Rep1_USR) Then
         RepT_USR = CreateFldr(Rep1_USR)
      Else
         RepT_USR = FSO.GetFolder (Rep1_USR)
      End If
   Else
      If Not FSO.FolderExists(Rep1_USR & "\" & BVP_User) Then
         RepT_USR = CreateFldr( Rep1_USR & "\" & BVP_User)
      Else
         RepT_USR = FSO.GetFolder (Rep1_USR & "\" & BVP_User)
      End If
   End If

End If

If c_error = 0 Then
' Parameter's Procedure
' Execution of PACAGP
'---------------------
    BVPACAGP = " "
    If FSO.FileExists(WshEnv("BVPACAGP")) Then
       BVPACAGP = WshEnv("BVPACAGP")
       BVPACAGP = chr(34) & BVPACAGP & chr(34) & " " & _
                BVP_User & " " & NumP &  _
    " " & chr(34) & Rep_USR & chr(34) & " " & RetGP
    End If

If (MyProc = "MIBA" Or MyProc = "MIBR" _
    Or MyProc = "MIBJ" Or MyProc = "MIBU") Then
'Assignation Miba File
'-----------------------
   MIAMPMAC = WshEnv("BVP_MibaFile")
   If (MIAMPMAC = "") Then
       MIAMPMAC = Rep_MD & "Mvmiba.txt"
       CreateNULF(MIAMPMAC)
   End If
   WshEnv("BVP_MibaFile") = MIAMPMAC
End If
 If (MyProc = "MIBA" Or MyProc = "MIBR" Or MyProc = "MIBU" _
     Or MyProc = "MIBJ" Or MyProc = "MIMA") Then
    BVP_MibaCs = WshEnv("BVP_MibaSpecChar")
    If (BVP_MibaCs = "") Then
         BVP_MibaCs = Rep_MD & "MibaSpecChar.txt"
        CreateNULF(BVP_MibaCs)
    End If
    WshEnv("BVP_MibaSpecChar") = BVP_MibaCs
 End If

If (MyProc = "MIAM") Then
   BVP_MiamCk = WshEnv("BVP_MiamParam")
   If (BVP_MiamCk = "") Then
    BVP_MiamCk = Rep_MD & "ParamMiam.txt"
    If Not FSO.FileExists(BVP_MiamCk) Then
    CreateNULF(BVP_MiamCk)
    Call CopFil(Rep_SKEL & "\BVPAMIAM",BVP_MiamCk)
    End If
   End If
   WshEnv("BVP_MiamParam") = BVP_MiamCk
End If

If MyProc = "MIBR" Or MyProc = "MIBJ" Then
   MIAMNR = WshEnv("BVP_MibrNotRet")
   If (MIAMNR = "") Then
        MIAMNR = Rep_MD & "Mvmibrnr.txt"
       CreateNULF(MIAMNR)
   End If
   WshEnv("BVP_MibrNotRet") = MIAMNR
   NMFILE = WshEnv("BVP_MibrNotStd")
   If (NMFILE = "") Then
        NMFILE = Rep_MD & "Mvmibrnm.txt"
       CreateNULF(NMFILE)
   End If
   WshEnv("BVP_MibrNotStd") = NMFILE
   NTFILE = WshEnv("BVP_MibrNRetUsr")
   If (NTFILE = "") Then
        NTFILE = Rep_MD & "Mvmibrnt.txt"
       CreateNULF(NTFILE)
   End If
   WshEnv("BVP_MibrNRetUsr") = NTFILE
   MIAMNS = WshEnv("BVP_MibrNotMig")
   If (MIAMNS = "") Then
        MIAMNS = Rep_MD & "Mvmibrns.txt"
       CreateNULF(MIAMNS)
   End If
   WshEnv("BVP_MibrNotMig") = MIAMNS
End If

If (MyProc = "MIBJ" Or MyProc = "MIBR" _
    Or MyProc = "MIBU") Then
   SPLITLIB = WshEnv("BVP_MibrSl")
   If (SPLITLIB = "") Then
       SPLITLIB = Rep_MD & "SPLITLIB.txt"
       CreateNULF(SPLITLIB)
   End If
   WshEnv("BVP_MibrSl")= SPLITLIB
End If

If (MyProc = "ERLD" Or MyProc = "ERUP") Then
   ERRLBL= WshEnv("BVP_ErrorLabel")
   If (ERRLBL= "") Then
       ERRLBL= Rep_MD & "ERRORLABEL.txt"
       CreateNULF(ERRLBL)
   End If
   WshEnv("BVP_ErrorLabel")= ERRLBL
End If

End If
If MyProc = "GRTD" Then
   GRTDMD = WshEnv("BVP_GrtdMd")
   If (GRTDMD = "") Then
       GRTDMD = Rep_USR & "\" & "GRTDMD.txt"
   End If
   WshEnv("BVP_GrtdMd")= GRTDMD
   GRTDMX = WshEnv("BVP_GrtdMx")
   If (GRTDMX = "") Then
       GRTDMX = Rep_MD & "GRTDMX.txt"
       CreateNULF(GRTDMX)
   End If
   WshEnv("BVP_GrtdMx")= GRTDMX
End If

WshVolEnv("RMsgLog") = Rep_USR

If err.number <> 0 Then
   EndJob (1)
End If
End If
